using Benner.Core.Abstractions;
using Benner.Core.Bef;
using Benner.Core.Extensions;
using Benner.Core.Infrastructure;
using Benner.Core.SuperServer.Client;
using Benner.NaiveService.API;
using Benner.NaiveService.API.Infrastructure.Entities;
using Benner.NaiveService.API.Services;

var builder = WebApplication.CreateBuilder(args);
builder.Services.AddControllers();
builder.Services.AddEndpointsApiExplorer();
builder.Services.AddSwaggerGen();

var superServerSettings = new SuperServerSettings { Host = "localhost", SystemName = "NOVO_01" };

//builder.Services
//    .AddScoped<IExemplosService, ExemplosService>()
//    .AddSuperServer(superServerSettings, connectionClient =>
//{
//    builder.Services.AddSingleton(typeof(IConnectionClient), connectionClient);
//    var dbConnectionSettings = connectionClient.GetDataAccessConnectionSettings();
//    builder.Services.AddBefSingletonContext(dbConnectionSettings, (contextFactory, mappingFactory) =>
//    {
//        mappingFactory.Add<IEstados, Estados>();
//        mappingFactory.Add<IMunicipios, Municipios>();
//    });
//});

new ServiceInfrastructureBuilder(superServerSettings, builder.Services, BefContextOptions.Singleton)
   .AddPlugin(new ExemploBefPlugin())
   .Build();

var app = builder.Build();

if (app.Environment.IsDevelopment())
{
    app.UseSwagger();
    app.UseSwaggerUI();
}

app.UseHttpsRedirection();

app.UseAuthorization();

app.MapControllers();
app.Run();


class SuperServerSettings : ISuperServerSettings
{
    public string Host { get; set; }

    public string SystemName { get; set; }

    public int? Port { get; set; }
}
